Attribute VB_Name = "HtmlHelper"
Option Explicit

Public AppRes As cWebArchive
Public ReadFromRes As Boolean
Public Crypt As cCrypt

Public Function Escape(text As String) As String
Dim ret As String
    ret = Replace$(text, "&", "&amp")
    ret = Replace$(text, "<", "&lt;")
    ret = Replace$(text, ">", "&gt;")
    ret = Replace$(text, """", "&quot;")
    ret = Replace$(text, "'", "&apos;")
    Escape = ret
End Function

Public Function CreateImgData(FileName As String, Optional p As String) As String
Dim fileType As String
    
    If AppRes.Exists(FileName) Then
        Select Case LCase$(Right$(FileName, 4))
            Case ".gif": fileType = "image/gif"
            Case ".png": fileType = "image/png"
            Case ".jpg": fileType = "image/jpg"
        End Select
        If Len(p) > 0 Then
            CreateImgData = "<img src='data:" & fileType & ";base64," & HtmlHelper.Crypt.Base64Enc(AppRes.GetContent(FileName)) & "' " & p & ">"
        Else
            CreateImgData = "<img src='data:" & fileType & ";base64," & HtmlHelper.Crypt.Base64Enc(AppRes.GetContent(FileName)) & "'>"
        End If
    Else
        Debug.Print FileName & " nicht gefunden!"
    End If
End Function

Public Function LoadResSvg(key As String) As String
    Dim svg As String
    svg = HtmlHelper.Crypt.UTF8ToVBString(AppRes.GetContent(key))
    svg = Replace$(svg, """", "'")
    svg = Replace$(svg, "#", "%23")
    LoadResSvg = "data:image/svg+xml;utf8," & svg
End Function

Public Function CompColor(color As String) As String
Dim r As String, g As String, b As String
Const dark As Integer = 450
    If Len(color) = 4 Then
        r = Mid$(color, 2, 1): g = Mid$(color, 3, 1): b = Mid$(color, 4, 1)
        If CLng("&H" & r & r) + CLng("&H" & g & g) + CLng("&H" & b & b) > dark Then CompColor = "#000" Else CompColor = "#fff"
    ElseIf Len(color) = 7 Then
        r = Mid$(color, 2, 2):  g = Mid$(color, 4, 2):  b = Mid$(color, 6, 2)
        If CLng("&H" & r) + CLng("&H" & g) + CLng("&H" & b) > dark Then CompColor = "#000" Else CompColor = "#fff"
    End If

End Function

