Attribute VB_Name = "mMain"
Option Explicit
Declare Function GetInstanceEx Lib "DirectCom" _
    (StrPtr_FName As Long, _
     StrPtr_ClassName As Long, _
     ByVal UseAlteredSearchPath As Boolean) As Object
Public New_c As cConstructor
Public AppPath As String
Public Cairo As cCairo
Public Debugger As Boolean
Public VW2Path As String
Private fMain As cfLiqPlan

Sub Main()
Dim cmd As String
Dim p() As String
Dim i As Integer, j As Integer
Dim fso As cFSO
    On Error GoTo Main_Error
    AppPath = App.Path
    If Right$(App.Path, 1) <> "\" Then AppPath = AppPath & "\"

    If App.LogMode Then
        Set New_c = GetInstanceEx(StrPtr(AppPath & "RC6.dll"), StrPtr("cConstructor"), True)
    Else
        Set New_c = New cConstructor
    End If

    cmd = Command
    cmd = Command
    If Len(cmd) Then
        p = Split(cmd, "--")
        For i = 0 To UBound(p)
            cmd = Trim$(p(i))
            j = InStr(cmd, "=")
            If j > 1 Then
                If LCase$(RTrim$(Left$(cmd, j - 1))) = "vw2path" Then
                    VW2Path = LTrim$(Mid$(cmd, j + 1))
                End If
            End If
            If LCase$(cmd) = "readfromres" Then
                HtmlHelper.ReadFromRes = True
            ElseIf LCase$(cmd) = "debugger" Then
                Debugger = True
            End If
        Next i
        If Len(VW2Path) Then
            Set fso = New_c.fso
            If Not fso.FolderExists(VW2Path) Then VW2Path = AppPath & VW2Path
            If Not fso.FolderExists(VW2Path) Then
                MsgBox "Der angegebene WiewView2 Pfad konnte nicht gefunden werden!" & vbCrLf & _
                    "Die Anwendung versucht die WiewView2 EverGreen-Veersion zu verwenden.", vbInformation, App.ProductName
                VW2Path = ""
            End If
        End If
    End If
    
    Set HtmlHelper.Crypt = New_c.Crypt
    Set HtmlHelper.AppRes = New_c.WebArchive
    With HtmlHelper.AppRes
        If App.LogMode = 0 Then
            .ReadContentsFromDirectory AppPath & "\Res\"
            .SaveContentsToArchiveFile AppPath & "\Bin\LiqPlan.war"
            HtmlHelper.ReadFromRes = True
        Else
            .ReadContentsFromArchiveFile AppPath & "\LiqPlan.war"
        End If
    End With
    Set Cairo = New_c.Cairo
    With Cairo
        .SetDPIAwareness
        .ImageList.AddIconFromByteArray "progIcn", HtmlHelper.AppRes.GetContent("liqplan16.png")
    End With
    
    Set fMain = New cfLiqPlan
    If Not fMain.Show Then Exit Sub
    
    If App.LogMode Then
        Cairo.WidgetForms.EnterMessageLoop True, True
    Else
        Load fDummy
        'fDummy.Show
    End If

    Exit Sub
    
Main_Error:
    Screen.MousePointer = vbDefault
    MsgBox "Fehler: " & Err.Number & vbCrLf & _
     "Beschreibung: " & Err.Description & vbCrLf & _
     "Quelle: mMain.Main." & Erl & vbCrLf & Err.Source, _
     vbCritical

End Sub







